function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}
import { renderless, api } from "@dft-vue-2-opentiny/vue-renderless/select-view/vue";
import { defineComponent, $prefix, $props, setup as _setup } from "@dft-vue-2-opentiny/vue-common";
import { iconCheck, iconCheckedSur, iconHalfselect, iconChevronUp, iconChevronDown, iconSearch, iconOperationfaild, iconChevronLeft } from "@dft-vue-2-opentiny/vue-icon";
import Button from "@dft-vue-2-opentiny/vue-button";
import ActionSheet from "@dft-vue-2-opentiny/vue-action-sheet";
import Exception from "@dft-vue-2-opentiny/vue-exception";
function normalizeComponent(scriptExports, render, staticRenderFns, functionalTemplate, injectStyles, scopeId, moduleIdentifier, shadowMode) {
  var options = typeof scriptExports === "function" ? scriptExports.options : scriptExports;
  if (render) {
    options.render = render;
    options.staticRenderFns = staticRenderFns;
    options._compiled = true;
  }
  if (functionalTemplate) {
    options.functional = true;
  }
  if (scopeId) {
    options._scopeId = "data-v-" + scopeId;
  }
  var hook;
  if (moduleIdentifier) {
    hook = function hook2(context) {
      context = context || // cached call
      this.$vnode && this.$vnode.ssrContext || // stateful
      this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext;
      if (!context && typeof __VUE_SSR_CONTEXT__ !== "undefined") {
        context = __VUE_SSR_CONTEXT__;
      }
      if (injectStyles) {
        injectStyles.call(this, context);
      }
      if (context && context._registeredComponents) {
        context._registeredComponents.add(moduleIdentifier);
      }
    };
    options._ssrRegister = hook;
  } else if (injectStyles) {
    hook = shadowMode ? function() {
      injectStyles.call(this, (options.functional ? this.parent : this).$root.$options.shadowRoot);
    } : injectStyles;
  }
  if (hook) {
    if (options.functional) {
      options._injectStyles = hook;
      var originalRender = options.render;
      options.render = function renderWithStyleInjection(h, context) {
        hook.call(context);
        return originalRender(h, context);
      };
    } else {
      var existing = options.beforeCreate;
      options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
    }
  }
  return {
    exports: scriptExports,
    options
  };
}

import InfiniteScroll from "@dft-vue-2-opentiny/vue-renderless/common/deps/infinite-scroll";
var render$1 = function render$12() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    staticClass: "flex items-start leading-5.5 py-3 cursor-pointer select-none border-b-0.5 border-color-bg-4",
    on: {
      "click": function click($event) {
        $event.stopPropagation();
        return _vm.$emit("click", $event);
      }
    }
  }, [_vm.multiple ? _c(_vm.selected ? "icon-checked-sur" : "icon-check", {
    tag: "component",
    class: ["flex-none w-4 h-4 mt-0.5 mr-3", _vm.selected && !_vm.readonly ? "fill-color-brand" : "fill-color-icon-disabled"]
  }) : _vm._e(), _c("div", {
    class: ["flex-auto truncate", {
      "text-color-brand": !_vm.multiple && _vm.selected
    }]
  }, [_vm._t("default")], 2)], 1);
};
var staticRenderFns$1 = [];
var __vue2_script$1 = defineComponent({
  inheritAttrs: false,
  emits: ["click"],
  components: {
    IconCheck: iconCheck(),
    IconCheckedSur: iconCheckedSur(),
    IconHalfselect: iconHalfselect()
  },
  props: {
    selected: Boolean,
    multiple: Boolean,
    readonly: Boolean
  }
});
var __cssModules$1 = {};
var __component__$1 = /* @__PURE__ */ normalizeComponent(__vue2_script$1, render$1, staticRenderFns$1, false, __vue2_injectStyles$1, null, null, null);
function __vue2_injectStyles$1(context) {
  for (var o in __cssModules$1) {
    this[o] = __cssModules$1[o];
  }
}
var Option = /* @__PURE__ */ function() {
  return __component__$1.exports;
}();
var __vue2_script = defineComponent({
  name: $prefix + "SelectView",
  emits: ["click", "update:text", "update:visible", "close", "update:modelValue", "search-click", "confirm"],
  directives: {
    InfiniteScroll
  },
  components: {
    TinyOption: Option,
    TinyActionSheet: ActionSheet,
    TinyButton: Button,
    TinyException: Exception,
    IconChevronUp: iconChevronUp(),
    IconChevronDown: iconChevronDown(),
    IconSearch: iconSearch(),
    IconOperationfaild: iconOperationfaild(),
    IconChevronLeft: iconChevronLeft()
  },
  props: _extends({}, $props, {
    menus: {
      type: Array,
      default: function _default() {
        return [];
      }
    },
    modelValue: [Number, String, Array],
    visible: {
      type: Boolean,
      default: false
    },
    valueField: {
      type: String,
      default: "id"
    },
    textField: {
      type: String,
      default: "label"
    },
    textField2: {
      type: String,
      default: ""
    },
    textField3: {
      type: String,
      default: ""
    },
    title: String,
    multiple: Boolean,
    searchConfig: {
      type: Object,
      default: function _default2() {
        return {
          searchMethod: null
        };
      }
    },
    topConfig: {
      type: Object,
      default: function _default3() {
        return {
          label: "",
          options: []
        };
      }
    },
    requiredSelectedList: {
      type: Array,
      default: function _default4() {
        return [];
      }
    },
    textSplit: {
      type: String,
      default: "; "
    },
    showHeader: {
      type: Boolean,
      default: true
    },
    customClass: [String, Object, Array],
    mask: {
      type: Boolean,
      default: true
    },
    infiniteScroll: {
      type: Object,
      default: function _default5() {
        return {
          load: null,
          delay: 200,
          disabled: true,
          distance: 0,
          immediate: true
        };
      }
    },
    lockScroll: {
      type: Boolean,
      default: true
    }
  }),
  setup: function setup(props, context) {
    return _setup({
      props,
      context,
      renderless,
      api,
      mono: true
    });
  }
});
var render = function render2() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    attrs: {
      "data-tag": "tiny-select-view"
    }
  }, [_c("tiny-action-sheet", {
    ref: "actionSheet",
    attrs: {
      "title": _vm.title,
      "lock-scroll": _vm.lockScroll,
      "mask": _vm.mask,
      "show-header": _vm.showHeader,
      "custom-class": _vm.m("h-full max-h-[100%] rounded-none text-color-text-primary pb-0", _vm.customClass),
      "visible": _vm.visible
    },
    on: {
      "update:visible": function updateVisible($event) {
        return _vm.$emit("update:visible", $event);
      }
    },
    scopedSlots: _vm._u([{
      key: "header-left",
      fn: function fn() {
        return [_c("IconChevronLeft", {
          staticClass: "h-5 w-5 fill-color-text-primary cursor-pointer",
          on: {
            "click": _vm.close
          }
        })];
      },
      proxy: true
    }, {
      key: "header-right",
      fn: function fn() {
        return [_c("div")];
      },
      proxy: true
    }])
  }, [_c("div", {
    class: ["flex flex-col flex-auto h-full"],
    attrs: {
      "data-tag": "tiny-select-view-inner text-color-text-primary"
    }
  }, [_c("div", {
    staticClass: "flex flex-none leading-6 py-2.5 px-4 text-base items-center border-b-0.5 border-color-bg-4 shadow-sm",
    attrs: {
      "data-tag": "select-view-header"
    }
  }, [_c("div", {
    staticClass: "flex-auto flex items-center h-7 py-1 px-3 bg-color-bg-4 rounded"
  }, [_c("IconSearch", {
    staticClass: "h-4 w-4 mr-1 fill-color-icon-disabled"
  }), _c("input", {
    directives: [{
      name: "model",
      rawName: "v-model",
      value: _vm.state.search.input,
      expression: "state.search.input"
    }],
    staticClass: "h-5 flex-auto text-xs bg-transparent outline-0",
    attrs: {
      "placeholder": _vm.t("ui.select.pleaseSearch")
    },
    domProps: {
      "value": _vm.state.search.input
    },
    on: {
      "keydown": function keydown($event) {
        if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "enter", 13, $event.key, "Enter"))
          return null;
        return _vm.searchMethod($event);
      },
      "input": function input($event) {
        if ($event.target.composing)
          return;
        _vm.$set(_vm.state.search, "input", $event.target.value);
      }
    }
  })], 1), _c("div", {
    staticClass: "flex items-center pl-3 cursor-pointer"
  }, [_c("div", {
    on: {
      "click": _vm.searchMethod
    }
  }, [_vm._v(_vm._s(_vm.t("ui.select.search")))])])]), _c("div", {
    staticClass: "flex-auto flex flex-col overflow-auto scrollbar-size-0",
    attrs: {
      "data-tag": "select-view-body"
    }
  }, [_vm.topConfig && _vm.topConfig.options.length ? _c("div", {
    staticClass: "leading-5.5 text-color-text-placeholder mx-4 border-b-0.5 border-color-bg-4",
    attrs: {
      "data-tag": "select-view-recommend"
    }
  }, [_vm.topConfig.label ? _c("div", {
    staticClass: "mt-4"
  }, [_vm._v(_vm._s(_vm.topConfig.label))]) : _vm._e(), _c("div", {
    staticClass: "mt-3"
  }, _vm._l(_vm.topConfig.options, function(item, index) {
    return _c("div", {
      key: item[_vm.valueField],
      class: ["max-w-full h-8 rounded-sm inline-flex truncate items-center px-2.5 cursor-pointer mb-3 mr-4 border-0.5", (_vm.multiple ? _vm.includeOptionIndex(_vm.state.checkList, item) > -1 : item[_vm.valueField] === _vm.modelValue) ? "border-current text-color-brand bg-color-bg-1" : "border-transparent bg-color-bg-2"],
      on: {
        "click": function click($event) {
          $event.stopPropagation();
          return _vm.searchSelectHandler(item, index);
        }
      }
    }, [_c("span", {
      class: [(_vm.multiple ? _vm.includeOptionIndex(_vm.state.checkList, item) > -1 : item[_vm.valueField] === _vm.modelValue) ? "text-color-brand" : "text-color-text-primary"]
    }, [_vm._v(_vm._s(item[_vm.textField]))]), _vm.textField2 ? _c("span", {
      class: ["ml-2.5", {
        "truncate": !_vm.textField3
      }]
    }, [_vm._v(_vm._s(item[_vm.textField2]))]) : _vm._e(), _vm.textField3 ? _c("span", {
      staticClass: "ml-2.5 truncate"
    }, [_vm._v(_vm._s(item[_vm.textField3]))]) : _vm._e()]);
  }), 0)]) : _vm._e(), _c("div", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: _vm.state.search.filterOptions.length,
      expression: "state.search.filterOptions.length"
    }, {
      name: "infinite-scroll",
      rawName: "v-infinite-scroll",
      value: _vm.load,
      expression: "load"
    }],
    class: ["px-4"],
    attrs: {
      "data-tag": "select-view-infinite-ccroll",
      "infinite-scroll-delay": _vm.infiniteScroll.delay,
      "infinite-scroll-disabled": _vm.infiniteScroll.disabled,
      "infinite-scroll-distance": _vm.infiniteScroll.distance,
      "infinite-scroll-immediate": _vm.infiniteScroll.immediate
    }
  }, _vm._l(_vm.state.search.filterOptions, function(item, index) {
    return _c("tiny-option", {
      key: item[_vm.valueField],
      attrs: {
        "multiple": _vm.multiple,
        "readonly": _vm.multiple && _vm.requiredSelectedList.indexOf(item[_vm.valueField]) !== -1,
        "selected": _vm.multiple ? _vm.includeOptionIndex(_vm.state.checkList, item) > -1 : item[_vm.valueField] === _vm.modelValue
      },
      on: {
        "click": function click($event) {
          return _vm.searchSelectHandler(item, index);
        }
      }
    }, [_vm._t("default", [_c("div", {
      staticClass: "flex"
    }, [_c("div", {
      class: [{
        "min-w-[theme(spacing.14)]": !_vm.textField3
      }]
    }, [_vm._v(_vm._s(item[_vm.textField]))]), _vm.textField2 ? _c("div", {
      staticClass: "ml-5 text-color-text-placeholder truncate"
    }, [_vm._v(_vm._s(item[_vm.textField2]))]) : _vm._e()]), _vm.textField3 ? _c("div", {
      staticClass: "text-color-text-placeholder truncate"
    }, [_vm._v(_vm._s(item[_vm.textField3]))]) : _vm._e()], {
      "item": item,
      "index": index
    })], 2);
  }), 1), _c("div", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: !_vm.state.search.filterOptions.length,
      expression: "!state.search.filterOptions.length"
    }],
    staticClass: "flex-auto w-full flex justify-center items-center text-center py-2",
    attrs: {
      "data-tag": "select-view-empty"
    }
  }, [_c("tiny-exception", {
    attrs: {
      "component-page": "",
      "type": "nodata"
    },
    scopedSlots: _vm._u([{
      key: "content",
      fn: function fn() {
        return [_vm._v(_vm._s(_vm.t("ui.select.noSearchData")))];
      },
      proxy: true
    }])
  })], 1), _c("div", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: _vm.state.search.loading && _vm.infiniteScroll.loadingText,
      expression: "state.search.loading && infiniteScroll.loadingText"
    }],
    staticClass: "w-full flex justify-center items-center text-center py-2",
    attrs: {
      "data-tag": "select-view-loading"
    }
  }, [_c("div", [_c("p", [_vm._v(_vm._s(_vm.infiniteScroll.loadingText))])])])]), _vm.multiple ? _c("div", {
    staticClass: "flex flex-none items-center py-4 px-3 border-t border-color-bg-4 shadow-sm",
    attrs: {
      "data-tag": "select-view-footer"
    }
  }, [_c("div", {
    staticClass: "cursor-pointer pr-2",
    on: {
      "click": function click($event) {
        $event.stopPropagation();
        return _vm.toggleCheckList(true);
      }
    }
  }, [_c("span", [_vm._v(_vm._s(_vm.t("ui.select.selectedNum", {
    num: _vm.state.checkList.length
  })))]), _c("IconChevronUp", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: _vm.state.checkList.length,
      expression: "state.checkList.length"
    }],
    staticClass: "flex-none w-4 h-4 ml-2 fill-current"
  })], 1), _c("div", {
    staticClass: "flex-auto"
  }), _c("tiny-button", {
    staticClass: "flex-none ml-3 w-28",
    attrs: {
      "tiny_mode": "mobile-first",
      "type": "primary",
      "size": "medium",
      "reset-time": 0
    },
    on: {
      "click": _vm.confirm
    }
  }, [_vm._v(" " + _vm._s(_vm.t("ui.button.confirm")) + " ")])], 1) : _vm._e()])]), _c("tiny-action-sheet", {
    attrs: {
      "custom-class": "h-3/4 text-color-text-primary",
      "title": _vm.t("ui.select.selected"),
      "show-footer": "",
      "lock-scroll": false,
      "menus": _vm.state.selected.options,
      "visible": _vm.state.selected.show
    },
    on: {
      "update:visible": function updateVisible($event) {
        _vm.state.selected.show = $event;
      }
    },
    scopedSlots: _vm._u([{
      key: "header-left",
      fn: function fn() {
        return [_c("div", {
          staticClass: "cursor-pointer text-color-text-placeholder",
          on: {
            "click": _vm.clean
          }
        }, [_vm._v(_vm._s(_vm.t("ui.datepicker.clear")))])];
      },
      proxy: true
    }, {
      key: "footer",
      fn: function fn() {
        return [_c("tiny-button", {
          attrs: {
            "tiny_mode": "mobile-first",
            "button-class": "flex-1 w-full mx-4 sm:mx-0",
            "type": "primary",
            "size": "medium",
            "reset-time": 0
          },
          on: {
            "click": function click($event) {
              return _vm.toggleCheckList(false);
            }
          }
        }, [_vm._v(" " + _vm._s(_vm.t("ui.button.confirm")) + " ")])];
      },
      proxy: true
    }])
  }, [_c("div", {
    staticClass: "h-full overflow-auto scrollbar-size-0"
  }, _vm._l(_vm.state.selected.options, function(item) {
    return _c("tiny-option", {
      key: item[_vm.valueField]
    }, [_c("div", {
      staticClass: "flex px-4 items-center"
    }, [_c("div", {
      staticClass: "flex-auto truncate"
    }, [_c("div", {
      staticClass: "flex"
    }, [_c("div", {
      class: [{
        "min-w-[theme(spacing.14)]": !_vm.textField3
      }]
    }, [_vm._v(_vm._s(item[_vm.textField]))]), _vm.textField2 ? _c("div", {
      staticClass: "ml-5 text-color-text-placeholder truncate"
    }, [_vm._v(_vm._s(item[_vm.textField2]))]) : _vm._e()]), _vm.textField3 ? _c("div", {
      staticClass: "text-color-text-placeholder truncate"
    }, [_vm._v(_vm._s(item[_vm.textField3]))]) : _vm._e()]), _vm.requiredSelectedList.indexOf(item[_vm.valueField]) === -1 ? _c("div", {
      staticClass: "flex-none pl-4 text-right"
    }, [_c("IconOperationfaild", {
      staticClass: "w-5 h-5 fill-color-text-placeholder",
      on: {
        "click": function click($event) {
          return _vm.selectedOptionHandler(item);
        }
      }
    })], 1) : _vm._e()])]);
  }), 1)])], 1);
};
var staticRenderFns = [];
var __cssModules = {};
var __component__ = /* @__PURE__ */ normalizeComponent(__vue2_script, render, staticRenderFns, false, __vue2_injectStyles, null, null, null);
function __vue2_injectStyles(context) {
  for (var o in __cssModules) {
    this[o] = __cssModules[o];
  }
}
var SelectView = /* @__PURE__ */ function() {
  return __component__.exports;
}();
var version = "2.8.0";
SelectView.model = {
  prop: "modelValue",
  event: "update:modelValue"
};
SelectView.install = function(Vue) {
  Vue.component(SelectView.name, SelectView);
};
SelectView.version = version;
export {
  SelectView as default
};
